import React, { Component } from 'react';
import { IgrDataChart } from "igniteui-react-charts/ES5/igr-data-chart";
import { IgrDataChartCoreModule } from "igniteui-react-charts/ES5/igr-data-chart-core-module";
import { IgrDataChartCategoryModule } from "igniteui-react-charts/ES5/igr-data-chart-category-module";
import { IgrDataChartInteractivityModule } from "igniteui-react-charts/ES5/igr-data-chart-interactivity-module"

import { IgrNumericYAxis } from "igniteui-react-charts/ES5/igr-numeric-y-axis";
import { IgrCategoryXAxis } from "igniteui-react-charts/ES5/igr-category-x-axis";

import { IgrLineSeries } from "igniteui-react-charts/ES5/igr-line-series";

IgrDataChartCoreModule.register();
IgrDataChartCategoryModule.register();
IgrDataChartInteractivityModule.register();

export class SyncCharts extends Component {
  public data: any[];

  constructor(props: any) {
    super(props);

    this.onChartRef = this.onChartRef.bind(this);

    this.initData();
  }

  render() {
    return (
      <div className="sample">
        <div className="chart1">
          <IgrDataChart ref={this.onChartRef} isHorizontalZoomEnabled={true} isVerticalZoomEnabled={true}
            width="600px"
            height="400px"
            dataSource={this.data} >
            {/* at least 2 axes are required: */}
            <IgrCategoryXAxis name="xAxis" label="Country" />
            <IgrNumericYAxis name="yAxis" minimumValue={0} />

            <IgrLineSeries name="series1" xAxisName="xAxis" yAxisName="yAxis" valueMemberPath="Coal" />
          </IgrDataChart>
        </div>
        <div className="chart2">
          <IgrDataChart ref={this.onChartRef} isHorizontalZoomEnabled={true} isVerticalZoomEnabled={true}
            width="600px"
            height="400px"
            dataSource={this.data} >
            {/* at least 2 axes are required: */}
            <IgrCategoryXAxis name="xAxis2" label="Country" />
            <IgrNumericYAxis name="yAxis2" minimumValue={0} />

            <IgrLineSeries name="series2" xAxisName="xAxis2" yAxisName="yAxis2" valueMemberPath="Coal" />
          </IgrDataChart>
        </div>
      </div >
    );
  }

  public initData() {
    this.data = [
      { Country: "Canada", Coal: 400, Oil: 100, Gas: 175, Nuclear: 225, Hydro: 350 },
      { Country: "China", Coal: 925, Oil: 200, Gas: 350, Nuclear: 400, Hydro: 625 },
      { Country: "Russia", Coal: 550, Oil: 200, Gas: 250, Nuclear: 475, Hydro: 425 },
      { Country: "Australia", Coal: 450, Oil: 100, Gas: 150, Nuclear: 175, Hydro: 350 },
      { Country: "United States", Coal: 800, Oil: 250, Gas: 475, Nuclear: 575, Hydro: 750 },
      { Country: "France", Coal: 375, Oil: 150, Gas: 350, Nuclear: 275, Hydro: 325 }
    ];
  }

  public onChartRef(chart: IgrDataChart) {
    if (chart != null) {
      chart.synchronizeHorizontally = true;
      chart.synchronizeVertically = true;  
      chart.syncChannel = "ChannelA";
      //this.setSeries("Stacked Column Series")
    }
  }
}